// @(#) DataConnectionTypeTest.java

package ohymosj;

import junit.framework.*;
import java.util.Vector;

public class DataConnectionTypeTest extends TestCase
{
  public DataConnectionTypeTest(String name) {
    super(name);
  }
  
  public void setUp() {
  }
  
  public void tearDown() {
  }

  // @begin{constructors check} ----------------------------------
  // @end{constructors check} ------------------------------------

  // @begin{methods check} ---------------------------------------

  public void test_parseDctVec() {
    Vector dv = DataConnectionType.parseDctVec(" 2 1 0");
    assertEquals("1", 2, dv.size());
    assertEquals("2", dv.get(0), DataConnectionType.STEP);
    assertEquals("3", dv.get(1), DataConnectionType.BROKENLINE);
    boolean catcherror = false;
    String message = null;
    try {
      Vector dve = DataConnectionType.parseDctVec(" 2 1 4");
    }
    catch (NumberFormatException e) {
      message = e.getMessage();
      catcherror = true;
    }
    assertEquals("4", true, catcherror);
    assertEquals("5",
      (Object)"invalid DataConnectionType number: 4", message);
  }

  public void test_toInt() {
    assertEquals("1", 0,
      DataConnectionType.BROKENLINE.toInt());
    assertEquals("2", 1,
      DataConnectionType.STEP.toInt());
    assertEquals("3", 2,
      DataConnectionType.PULSE.toInt());
    assertEquals("4", 3,
      DataConnectionType.NOINTP.toInt());
  }
  
  // @end{methods check} -----------------------------------------
}

