/**
 * @(#) OhArrayList;
 *
 */

package ohymosj;

import java.util.*;
import java.io.*;

/**
 * The OhArrayList class extends the ArrayList class and
 * add a method <a href="OhArrayList.html#method_summary">removeHeadRange()</a>.
 * <p>
 *
 * <japanese>
 * NX OhArrayList ́ANX ArrayList pč쐬
 * ܂B<p>
 *
 * ohymosj ł́AԏɒǉAԂ̌Â̂svɂȂ
 * Ă悤ȈÃf[^^̂ɁÃf[^\
 * OhArrayList gp̂Ƃ܂B
 * <p>
 *
 * NX <a href="OhSendPort.html">OhSendPort</a> ŁAOhArrayList ^̃tB[hϐ
 *  <a href="OhDataPack.html">OhDataPack</a> ^hf[^^̃f[^^
 * Ă܂B
 * <p>
 *
 * NX ArrayList ́Aẑ悤ɃCfbNXɂčɗv
 * f̒lQƂłAi[vfvO̒Ŋg傷邱
 * Ƃł܂BAsvɂȂ擪vf (ʂ擪̈
 * ̗vfłȂAXg̐擪ɈʒuA̗vf̂Ƃ
 * u擪vfvƌƂɂ܂) 폜ɂ͎Ԃ
 * BႦ΁A擪̈폜ꍇÄ폜邾
 * łȂA2Ԗڈȍ~̗vfOɈ炵ĈڂςƂ
 * KvɂȂ邩łBXg̃TCY傫ȂƁȂOɈ
 * ςƂɂ鎞Ԃ傫Ȃ܂B
 * <p>
 *
 * ŁA擪vf̍폜ɎԂƂlāAN
 * X OhArrayList ł́AsvɂȂ擪vf萔܂܂
 * ́A擪vf̍폜ƂsȂƂ@\g݂܂B
 * <p>
 *
 * public void removeHeadRange(int aIndex) ́A擪ACfb
 * NX aIndex -1 ̗vf܂ł폜郁\bhłBۂɁA
 * 邩ǂ́A폜 aIndex AŜ̗vf̌4
 * 1ȏł邩ǂŔf܂BsvɂȂč폜ׂv
 * f̂ɁA폜Ƃ扄΂ɂĂ邽߂ɁA擪ɕsv
 * ȗvf邱ƂɂȂ̂ŁAӖŏ̃CfbNX
 * LĂƂɂAԂ\bh getStartIndex() p
 * ӂĂ܂B
 * <p>
 *
 * NX ArrayList ̃IuWFNg a ŁAӖvf̃Cfb
 * NX k ͈̔͂́Aa.getStartIndex() <= k < a.size() łB
 * <p>
 * </japanese>
 *
 * @author satoh, shiiba
 * @version $Revision: 1.7 $ $Date: 2003/12/16 11:43:57 $
 */
public class OhArrayList extends ArrayList {

  // @begin{field} ---------------------------------------------

  /**
   * Start index of elements which are needed for future
   * work using this list. The elements whose index ranges from
   * 0 to <b>_startIndex</b> - 1 are retained in the list, but
   * they are not needed for future work, and are waiting for
   * being eliminated by the use of the <b>removeHeadRange()</b>
   * method.
   * <p>
   *
   * <japanese>
   * ̃XggpƂӖ̂ŏ̗vf̃CfbNXB
   * 0  <b>_startIndex</b> - 1 ܂ł͈̔͂̃CfbNX
   * vf́A܂̃XgɕێĂ܂svȂ
   * ŁA<b>removeHeadRange()</b> \bhgpč폜
   * ҂Ă܂B
   * </japanese>
   */
  private int _startIndex;

  // @end{field} -----------------------------------------------


  // @begin{constructor} ---------------------------------------

  /**
   * Creates a new <b>OhArrayList</b> instance with
   * <b>_startIndex</b> = 0.
   *
   */
  public OhArrayList() {
    _startIndex = 0;
  }

  // @end{constructor} -----------------------------------------
  
  // @begin{methods} -------------------------------------------

  /**
   * Returns <b>_startIndex</b>. The elements whose index
   * ranges from 0 to <b>_startIndex</b> - 1 are retained in the
   * list, but they are not needed for future work, and are
   * waiting for being eliminated.
   * <p>
   *
   * Sample of using <b>getStartIndex()</b>, where <b>list</b> is
   * an OhArrayList object:
   * <p>
   * <pre>
   *   for (int i = list.getStartIndex(); i < list.size(); i++) {
   *     System.out.println(list.get(i));
   *   }
   * </pre>
   * @return an <code>int</code> value
   */
  public int getStartIndex() {
    return _startIndex;
  }

  /**
   * Returns the last Object object stored in this list
   *
   * @return an <code>Object</code> value
   */
  public Object getLastElement() {
    return get(size() - 1);
  }

  /**
   * Tries to remove the first part of the elements of this list
   * whose index ranges from 0 to <b>aIndex</b> - 1.  If
   * <b>aIndex</b> is less than or equal to
   * <b>_startIndex</b>, no elements are removed. If <b>size()</b>
   * is greater than or equal to 12 and <b>aIndex</b> &lt;
   * <b>size()</b>/4, <b>_startIndex</b> is updated to <b>aIndex</b>.
   * Otherwise, the elements with indexes from from 0 to
   * <b>aIndex</b> - 1 are actually removed and
   * <b>_startIndex</b> is updated to 0.
   * <p>
   *
   * <japanese>
   * 0  <b>aIndex</b> - 1 ͈̔͂̃CfbNX
   * <b>aIndex</b>̗vf
   * 悤Ƃ܂B<b>aIndex</b> 
   * <b>_startIndex</b> 菬ꍇ́A܂B
   * XgɊi[Ăvf 12 ȏŁA<b>size()</b>/4
   * 菬ꍇ́A폜𗯕ۂāA<b>_startIndex</b> 
   * <b>aIndex</b> ɕύX܂BȊȌꍇ́AۂɁA
   * 0  <b>aIndex</b> - 1 ͈̔͂̃CfbNXv
   * f폜A<b>_startIndex</b>  0 ɐݒ肵܂B
   * </japanese>
   *
   * @param aIndex an <code>int</code> value
   */
  public void removeHeadRange(int aIndex) {
    if (aIndex < _startIndex) {
      return;
    }
    else if (size() >= 12 && aIndex < (size()/4)) {
      _startIndex = aIndex;
      return;
    }
    else {
      super.removeRange(0, aIndex);
      _startIndex = 0;
    }
  }

  // @end{methods} ---------------------------------------------

}
