// @(#) OhInputFileTest.java

package ohymosj;

import junit.framework.*;
import java.io.*;
import java.util.*;

/**
 * <japanese>
 * <a href="OhInputFile.html">OhInputFile</a> ͒ۃNXłB{iIȃeXǵA
 * OhInputFile p <a href="OhInputFileDouble.html">OhInputFileDouble</a> ̃eXgŎ
 * s܂B<a href="OhInputFileDoubleTest.html">OhInputFileDoubleTest</a> QƁB
 * </japanese>
 *
 * @author shiiba
 * @version 1.0
 */
public class OhInputFileTest extends TestCase
  implements OhConst
{
  
  public OhInputFileTest(String name) {
    super(name);
  }
  
  public void setUp() {
  }
  
  public void tearDown() {
  }

  class OhInputFileMoc extends OhInputFile {
    public String dataType() {
      return "double";
    }
    public void sendByString(String aDataStr) {
      OhDataPackDouble dp = new OhDataPackDouble(aDataStr);
      dataPackStock(dp);
    }
    public void inputData() {}
    public OhDataPack makeDataPack(String aLineData) {
      OhDataPackDouble dp = new OhDataPackDouble(aLineData);
      return dp;
    }
    public OhInputFileMoc(String aFileName) {
      super(aFileName);
    }
    public OhInputFileMoc() {
      super();
    }
  }

  // @begin{constructors check} ----------------------------------

  public void test_constructors() {
    OhInputFile fi = new OhInputFileMoc("foo");
    assertEquals("1", (Object)"OhInputFile", fi.getClassName());
    assertEquals("2", (Object)"foo", fi.getObjectName());
    assertEquals("3", 0, fi.getObjectNumber());
  }
  
  // @end{constructors check} ------------------------------------

  // @begin{methods check} ---------------------------------------

  public void test_calReq() {
    /*
    OhInputFile fi = new OhInputFileMoc("kyoto.txt");
    boolean throwflag = false;
    String message = null;
    try {
      fi.calReq();
    }
    catch (OhCannotGetDataError e) {
      throwflag = true;
      message = e.what();
    }
    catch (OhError e) {
    }
    assertEquals("1", true, throwflag);
    assertEquals("2", message,
      "Cannot get data from kyoto.txt");
    */
  }

  public void test_cPrint() {
    OhInputFile fi = new OhInputFileMoc("foo.txt");
    StringWriter buffer = new StringWriter();
    PrintWriter out = new PrintWriter(buffer);
    fi.cPrint(out, "# ");
    String result = buffer.toString();
    out.close();
    String expected = "# " +
      "OhInputFile foo.txt" + NEWLINE;
    assertEquals("1", (Object)expected, result);
  }

  public void test_makeDataPack() {
    OhInputFile fi = new OhInputFileMoc();
    OhDataPack dp = fi.makeDataPack("2003 0 0.0 1.5");
    assertEquals("1", true,
      (new OhTimePoint(2003, 0, 0.0)).equals(dp.getDataTime()));
    assertEquals("2", 1.5,
      ((OhDataPackDouble) dp).getDataValue(), 0.001);
  }

  public void test_sendByString() throws OhError {
    OhInputFile fi = new OhInputFileMoc();
    fi.doSwitch();
    fi.sendByString("2003 0 0.0 1.5");
    fi.setDataPackArray();
    assertEquals("1", true,
      fi.getNewestDataTime().equals(
        (new OhTimePoint(2003,0,0.0)), 0.001));
  }

  public void test_inputData() {
    // inputData ̃eXǵAOhInputFileDoubleTest.java Ɉς˂
    // B
  }

  public void test_oPrint() {
    OhInputFile fi = new OhInputFileMoc("foo.txt");
    StringWriter buffer = new StringWriter();
    PrintWriter out = new PrintWriter(buffer);
    fi.oPrint(out, "# ");
    String result = buffer.toString();
    out.close();
    String expected = "# " +
      "OhInputFile foo.txt" + NEWLINE;
    assertEquals("1", (Object)expected, result);
  }

  
  // @end{methods check} -----------------------------------------
}

