// @(#) OhObjectTest.java

package ohymosj;

import junit.framework.*;
import java.io.*;
// import java.util.regex.*;

public class OhObjectTest extends TestCase
  implements OhConst
{
  OhObject _a;
  OhObject _b;
  
  public OhObjectTest(String name) {
    super(name);
  }
  
  public void setUp() {
    _a = new OhObject();
    _b = new OhObject();
    try {
      _b.init("basin", 1);
    }
    catch (OhError e) {
    }
  }
  
  public void tearDown() {
  }

  // @begin{constructors check} ----------------------------------
  // @end{constructors check} ------------------------------------

  // @begin{methods check} ---------------------------------------

  public void test_init() {
    OhObject obj = new OhObject("Kyoto", 0);
    boolean initcatch = false;
    try {
      obj.init("Saga", 0);
    }
    catch (OhError oe) {
      if (false) {
        System.out.println(oe.what());
        oe.printStackTrace();
      }
      initcatch = true;
    }
    if (!initcatch) {
      fail("init catch fail");
    }
  }

  public void test_getClassName() {
    assertEquals("test_getClassNameA", (Object)"OhObject",
      _a.getClassName());
  }
  
  public void test_getObjectName() {
    assertEquals("test_getObjectNameA", (Object)"basin",
      _b.getObjectName());
  }

  public void test_getObjectNumber() {
    assertEquals("test_getObjectNumberA", -1, _a.getObjectNumber());
    assertEquals("test_getObjectNumberA",  1, _b.getObjectNumber());
  }

  public void test_getOwner() {
    assertEquals("test_getOwnerA", null, _a.getOwner());
    try {
      _a.setOwner(_b);
    }
    catch (OhError e) {
    }
    assertEquals("test_getOwnerB", _b, _a.getOwner());
    OhObject c = new OhObject("foo", 2);
    try {
      _b.setOwner(c);
    }
    catch (OhError e) {
    }
    /*
    Pattern p = Pattern.compile("^", Pattern.MULTILINE);
    Matcher matcher = p.matcher(_a.toString());
    String output = matcher.replaceAll("\t\t");
    System.out.println(output);
    */
  }

  public void test_cPrintString() throws OhError {
    OhObject tokyo = new OhObject("Tokyo", 7);
    String expected =
      "> OhObject Tokyo 7" + NEWLINE;
    assertEquals("1", (Object)expected,
      tokyo.cPrintString("> "));
  }
  
  public void test_oPrintString() throws OhError {
    OhObject tokyo = new OhObject("Tokyo", 0);
    OhObject kyoto = new OhObject("Kyoto", 1);
    kyoto.setOwner(tokyo);
    String expected =
      "> (" + NEWLINE +
      ">  OhObject Kyoto 1" + NEWLINE +
      ">  OhObject Tokyo 0" + NEWLINE +
      "> )" + NEWLINE;
    assertEquals("1", (Object)expected, kyoto.oPrintString("> "));
  }
  
  // @end{methods check} -----------------------------------------
}

