/**
 * @(#) OhRelayInt
 *
 */

package ohymosj;

import java.util.*;
import java.io.*;

/**
 * The OhRelayInt class is a class of port which relays
 * datapacks of type int.
 *
 * @author satoh, shiiba
 * @version $Revision: 1.2 $ $Date: 2004/01/17 13:38:58 $
 */
public class OhRelayInt extends OhRelayPort
{
  // @begin{initialization} ----------------------------------------------

  /**
   * Initialization.
   *
   * @param aPortName a <code>String</code> value
   * @param aPortNum an <code>int</code> value
   * @exception OhError if an error occurs
   */
  public void init(String aPortName, int aPortNum)
    throws OhError {
    super.init(aPortName, aPortNum);
  }

  // @end{initialization} ------------------------------------------------
  
  
  // @begin {constructors} -----------------------------------------------

  /**
   * Creates a new default <code>OhRelayInt</code> instance.
   */
  public OhRelayInt() {
    super();
    _className = "OhRelayInt";
  }

  
  /**
   * Creates a new <code>OhRelayInt</code> instance.
   *
   * @param aPortName a <code>String</code> value
   * @param aPortNum an <code>int</code> value
   * @exception OhError if an error occurs
   */
  public OhRelayInt(String aPortName, int aPortNum) {
    super(aPortName, aPortNum);
    _className = "OhRelayInt";
  }

  // @end {constructors} -------------------------------------------------

  
  // @begin {methods} ----------------------------------------------------

  /**
   * Returns the data pack type which expresses the type of data to be received.
   *
   * @return a <code>String</code> value
   */
  public String dataType() {
    return "int";
  }

  // @end {methods} ------------------------------------------------------

} // OhRelayInt
