;;; -*- Mode: Emacs-lisp ; Codeing: iso-2022-jp -*-
; @(#) msjavaenv.el
;
; msjavaenv for windows
;
(defun my-java-set-package (string)
  "set java package name (ex. ohymosj)"
  (interactive "sPackage name (ex. ohymosj): ")
  (setenv "JAVA_PACKAGE" string)
  )

(defun my-java-set-root (dir)
  "set java project root (ex. ~/base/ohymosj/ohymosj-2.0): "
  (interactive
    "DProject root name (ex. ~/base/ohymosj/ohymosj-2.0): ")
  (setq dir (dired-replace-in-string "/$" "" dir))
  (setenv "JAVA_PROJECT_ROOT" dir))

; (getenv "JAVA_PROJECT_ROOT")

(defun my-java-set-url ()
  "set java-url"
  (interactive)
  (let (url)
    (setq url
      (read-string "java-url: " "jp/ac/kyoto_u/kuciv/hywr/"))
    (setenv "JAVA_URL" url)))

; (getenv "JAVA_URL")
  
(defun my-java-directory (string)
  "show java source directories"
  (interactive "smain or test: ")
  (let (jp predir main test package)
    (setq predir (getenv "JAVA_PROJECT_ROOT"))
    (setq package (getenv "JAVA_PACKAGE"))
    (setq jp (getenv "JAVA_URL"))
    (setq main (concat predir "/src/main/" jp package))
    (setq test (concat predir "/src/test/" jp package))
    (dired main)
    (dired-other-window test)
  )
)

(defun my-java-root-directory ()
  "show java package root directories"
  (interactive)
  (let (root)
    (setq root (getenv "JAVA_PROJECT_ROOT"))
    (dired root)
  )
)
  
(defun my-java-main-directory ()
  "show java source directories"
  (interactive)
  (let (jp predir main test package)
    (setq predir (getenv "JAVA_PROJECT_ROOT"))
    (setq package (getenv "JAVA_PACKAGE"))
    (setq jp (getenv "JAVA_URL"))
    (setq main (concat predir "/src/main/" jp package))
    ; (dired main)
    (doctable main)
  )
)

(defun my-java-src-directory ()
  "show java source directories"
  (interactive)
  (let (jp predir main test package)
    (setq predir (getenv "JAVA_PROJECT_ROOT"))
    (setq package (getenv "JAVA_PACKAGE"))
    (setq jp (getenv "JAVA_URL"))
    (setq main (concat predir "/src/" jp package))
    ; (dired main)
    (doctable main)
  )
)

(defun my-java-test-directory ()
  "show java source directories"
  (interactive)
  (let (jp predir test main package)
    (setq predir (getenv "JAVA_PROJECT_ROOT"))
    (setq package (getenv "JAVA_PACKAGE"))
    (setq jp (getenv "JAVA_URL"))
    (setq test (concat predir "/src/test/" jp package))
    ; (delete-other-windows)
    ; (dired test)
    (doctable test)
  )
)
  
(defun my-java-getjavaenv ()
  "load javaenv.el"
  (interactive)
  (load "javaenv.el"))

(defun my-java-savejavaenv ()
  "save javaenv to ~/tbin/getjavaenv"
  (interactive)
  (find-file "~/tbin/getjavaenv")
  (erase-buffer)
  (insert "#! /bin/sh\n")
  (insert "export JAVA_PROJECT_ROOT="
    (getenv "JAVA_PROJECT_ROOT") "\n")
  (insert "export JAVA_PACKAGE="
    (getenv "JAVA_PACKAGE") "\n")
  (insert "export JAVA_URL="
    (getenv "JAVA_URL") "\n")
  (save-buffer (current-buffer))
  (kill-buffer (current-buffer)))

; $B8=:_JT=8Cf$N%P%C%U%!$K(B junit $B$N%a%=%C%I$N%F%9%H%3!<%I$N%9%1%k(B
; $B%H%s$rA^F~$7$^$9!#%a%=%C%IL>$O!"$"$i$+$8$a%-%k%j%s%0$N@hF,$K<}(B
; $BO?$5$l$F$$$k$H2>Dj$7$F$$$^$9!#(B
;
; $B%a%=%C%IL>$r%-%k%j%s%0$N@hF,$K<}O?$9$k$K$O!"(Bmygetword $B$r;HMQ$9(B
; $B$k$H4JC1$G$9!#(Bmygetword $B$O!"(B(File "~/winelisp/msmiscwin.el")
; $B$K<}O?$5$l$F$$$^$9!#(B
(defun my-java-insert-test-method ()
    "insert test-method skelton"
    (interactive)
    (beginning-of-line)
    (insert "  public void test_")
    (yank)
    (insert "() {\n  }\n"))


(defun striphreftag ()
  (interactive)
  (query-replace-regexp "<a href=\"[^\"]+\">\\([^<]+\\)</a>"
  "\\1"))

;# Jump a point corresponding to the specified argument string.
;#
;# Style 1: (Ref "OhObject")
;# Style 2: (Ref "OhObject#init(String, int)")
;# Style 3: (Ref "OhObject#foo")
;# Style 4: (Ref "#init(String, int)") or (Ref "#foo")
;#
;# For style 1, jump to the file "OhObject.java".
;# For style 2, jump to the file "OhObject.java" and search 
;# "^[_0-9a-zA-Z ]+ init("
;# For style 3, jump to the file "OhObject.java" and search 
;# "^[_0-9a-zA-Z ]+ foo;"
;#
;# You can use . (period) in place of #.
;#
;# Because this funcion executes push-mark for the current
;# position before its jump, you can go back to the original
;# position by typing C-u C-SPACE if the target position is
;# located within the current buffer.
(defun Ref (target)
  "jump to the target"
  (interactive "starget: ")
  (let (predir)
    (setq predir "")
    (if (string-match "/test/" default-directory)
	(setq predir 
	      (dired-replace-in-string 
	       "/test/" "/main/" default-directory)))
    (if (string-match "Test" target)
	(setq predir
	      (dired-replace-in-string 
	       "/main/" "/test/" default-directory)))
    (if (string-match "^\\w+$" target)
    ; style 1
    (find-file (concat predir target ".java"))
    ; style 2 or 3 or 4
    (if (string-match "^\\([^.#]*\\)[.#]\\([^(]+\\)(" target)
      ; style 2: (Ref "OhObject#init(String, int)")
      (progn
        (let (classname method-name)
          (setq classname (concat
            (substring target (match-beginning 1) (match-end 1))))
          (setq method-name
            (concat " " (substring target
              (match-beginning 2) (match-end 2)) "("))
	  (if (not (= (length classname) 0))
	      (find-file (concat predir classname ".java")))
	  (push-mark (point))
	  (goto-char (point-min))
          (setq method-name 
		(concat "^  [a-zA-Z][][_0-9a-zA-Z ]+" method-name))
          (kill-new method-name)

          (re-search-forward method-name)))
      ; style 3 (Ref "OhObject#foo")
      (if (string-match "^\\([^.#]*\\)[.#]\\([^(]+\\)" target)
	  (progn
	    (let (classname field-name)
	      (setq classname (concat
		 (substring target 
			    (match-beginning 1) (match-end 1))))
	      (setq field-name
		    (concat " " (substring target
		    (match-beginning 2) (match-end 2)) ".*;"))
	      (if (not (= (length classname) 0))
		  (find-file (concat predir classname ".java")))
	      (setq field-name 
		    (concat "^  [a-zA-Z][][_0-9a-zA-Z ]+" field-name))
	      (kill-new field-name)
	      (push-mark (point))
	      (goto-char (point-min))
	      (re-search-forward field-name))))
      ))))

(defun Refagain ()
  (interactive)
  (re-search-forward (current-kill 1)))
      

(defun tobold ()
  "replace enclosing quotation marks with <b>...</b>"
  (interactive)
  (while (not (or (= (char-after (point)) ?\")
		  (= (char-after (point)) ?')))
    (backward-char))
  (delete-char 1) (insert "<b>")
  (while (not (or (= (char-after (point)) ?\")
		  (= (char-after (point)) ?')))
    (forward-char))
  (delete-char 1) (insert "</b>") )

;;  'foobar' "foobar"