// @(#) OhAllignTextTest.java

package ohymosj;

import junit.framework.*;
import java.lang.reflect.Field;

public class OhAllignTextTest extends TestCase
{
  public OhAllignTextTest(String name) {
    super(name);
  }
  
  public void setUp() {
  }
  
  public void tearDown() {
  }

  // @begin{constructors check} ----------------------------------

  public void test_constructors() throws Exception {
    OhAllignText line;
    Class c;
    Field nameField;
    
    // ---------------------------------------------------------

    line = new OhAllignText();
    c = line.getClass();

    nameField = c.getDeclaredField("_tabpos");
    nameField.setAccessible(true); 
    assertEquals("1", null, nameField.get(line));

    nameField = c.getDeclaredField("_ntab");
    nameField.setAccessible(true); 
    assertEquals("2", 0, nameField.getInt(line));

    nameField = c.getDeclaredField("_column");
    nameField.setAccessible(true); 
    assertEquals("3", 0, nameField.getInt(line));
    
    // ---------------------------------------------------------

    int[] tabpos = {4, 16, 24};
    line = new OhAllignText(tabpos);
    c = line.getClass();
    
    nameField = c.getDeclaredField("_tabpos");
    nameField.setAccessible(true);
    int[] ntabpos = (int[])nameField.get(line);
    assertEquals("11", 3, ntabpos.length);
  }
  
  // @end{constructors check} ------------------------------------

  // @begin{methods check} ---------------------------------------

  public void test_put() {
    OhAllignText line = new OhAllignText(new int[] {4,16,24});
    line.put("m.");
    assertEquals("1", (Object)"    m.", line.toString());

    line.put(" shiiba");
    assertEquals("2", (Object)"    m. shiiba", line.toString());
  }

  public void test_nextColumn() {
    OhAllignText line = new OhAllignText(new int[] {2, 14, 26});
    line.put("shiiba");
    line.nextColumn();
    line.put("michiharu");
    line.nextColumn();
    line.put("old");
    assertEquals("1", (Object)"  shiiba      michiharu   old",
      line.toString());
    line.clear();
    line.put("hori");
    line.nextColumn();
    line.put("tomoharu");
    line.nextColumn();
    line.put("middle");
    assertEquals("1", (Object)"  hori        tomoharu    middle",
      line.toString());

    line = new OhAllignText();
    line.put("shiiba");
    line.nextColumn();
    line.put("michiharu");
    line.nextColumn();
    line.put("old");
    assertEquals("1", (Object)"shiiba  michiharu old",
      //                       123456789012345678901234567890
      line.toString());
    
    line.clear();
    line.put("shiiba");
    line.nextColumn();
    line.put("miyuki");
    line.nextColumn();
    line.put("young");
    assertEquals("1", (Object)"shiiba  miyuki  young",
      //                       123456789012345678901234567890
      line.toString());

  }
    
  // @end{methods check} -----------------------------------------
}

