/**
 * @(#) Service methods used throughout Ohymos
 */

package ohymosj;

import java.io.*;
import java.util.regex.*;

/**
 * Service methods used throughout Ohymos
 *
 * @author shiiba
 * @version 1.0
 */
public class OhCommon implements OhConst
{
  // @begin{static methods} ------------------------------------

  /**
   * Add <b>aPrefix</b> to each line contained in
   * <b>aMultipleLineString</b> and returns the resultant string.
   * <p>
   *
   * <japanese>
   * <p>
   * <b>aMultipleLineString</b> Ɋ܂܂Ăes̍sɁA
   * <b>aPrefix</b>
   * tĕԂ܂B
   * </japanese>
   *
   * @param aMultipleLineString a <code>String</code> value
   * @param aPrefix a <code>String</code> value
   * @return a <code>String</code> value
   */
  public static String addPrefix(
    String aMultipleLineString,
    String aPrefix)
  {
    Pattern p = Pattern.compile("^", Pattern.MULTILINE);
    Matcher matcher = p.matcher(aMultipleLineString);
    return matcher.replaceAll(aPrefix);
  }

  // -----------------------------------------------------------


  // @end{static methods} --------------------------------------
}
