// @(#) OhReceiveDoubleTest.java

package ohymosj;

import junit.framework.*;
import java.util.Vector;

// (Ref "OhReceiveDouble")
// (Ref "OhReceivePort")

public class OhReceiveDoubleTest extends TestCase
{
  public OhReceiveDoubleTest(String name) {
    super(name);
  }
  
  public void setUp() {
  }
  
  public void tearDown() {
  }

  // @begin{constructors check} ----------------------------------
  
  public void test_constructors() {
    OhReceiveDouble rp = new OhReceiveDouble();
    assertEquals("1", "OhReceiveDouble", rp.getClassName());

    rp = new OhReceiveDouble("rp", 0);
    assertEquals("2", "rp", rp.getObjectName());
    assertEquals("2", 0, rp.getObjectNumber());
  }

  // @end{constructors check} ------------------------------------

  // @begin{methods check} ---------------------------------------
  
  public void test_dataType() {
    OhReceiveDouble rp = new OhReceiveDouble();
    assertEquals("1", "double", rp.dataType());
  }

  public void test_getData() {
    // getData(OhTimePoint), BROKENLINE
    try {
      OhSendDouble sp = new OhSendDouble("sp", 0);
      sp.setDataConnectionType(DataConnectionType.BROKENLINE);
      OhReceiveDouble rp = new OhReceiveDouble();
      sp.registerReceiver(rp);
      rp.setSender(sp);
      sp.doSwitch();
      sp.sendByString("2003 10 0.0 1.0");
      sp.sendByString("2003 20 0.0 2.0");
      sp.sendByString("2003 30 0.0 3.0");
      sp.setDataPackArray();

      double d1 = rp.getData(
        new OhTimePoint(2003,12,0.0));
      assertEquals("1", 1.2, 
        d1, 0.001);
      assertEquals("2", 2.3,
        rp.getData(new OhTimePoint(2003,23,0.0)), 0.001);
      assertEquals("3", 1.0,
        rp.getData(new OhTimePoint(2003,5,0.0)), 0.001);
    }
    catch (OhError e) {
      System.out.println(e.what());
      fail();
    }

    // getData(OhTimePoint), STEP
    try {
      OhSendDouble sp = new OhSendDouble("sp", 0);
      sp.setDataConnectionType(DataConnectionType.STEP);
      OhReceiveDouble rp = new OhReceiveDouble();
      sp.registerReceiver(rp);
      rp.setSender(sp);
      sp.doSwitch();
      sp.sendByString("2003 10 0.0 1.0");
      sp.sendByString("2003 20 0.0 2.0");
      sp.sendByString("2003 30 0.0 3.0");
      sp.setDataPackArray();

      double d1 = rp.getData(new OhTimePoint(2003,12,0.0));
      assertEquals("1", 2.0, d1, 0.001);
      assertEquals("2", 3.0,
        rp.getData(new OhTimePoint(2003,23,0.0)), 0.001);
      assertEquals("3", 1.0,
        rp.getData(new OhTimePoint(2003,5,0.0)), 0.001);
    }
    catch (OhError e) {
      System.out.println(e.what());
      fail();
    }
    
    // getData(OhTimePoint, Vector)
    try {
      OhSendDouble sp = new OhSendDouble("sp", 0);
      OhReceiveDouble rp = new OhReceiveDouble();
      sp.registerReceiver(rp);
      rp.setSender(sp);
      sp.doSwitch();
      sp.sendByString("2003 10 0.0 1.0");
      sp.sendByString("2003 20 0.0 2.0");
      sp.sendByString("2003 30 0.0 3.0");
      sp.setDataPackArray();

      double d1 = rp.getData(
        new OhTimePoint(2003,12,0.0), sp.getDctVec());
      assertEquals("1", 1.2, 
        d1, 0.001);

      double d2 = rp.getData(
        new OhTimePoint(2003,23,0.0), sp.getDctVec());
      assertEquals("2", 2.3,
        d2, 0.001);
      
      double d3 = rp.getData(
        new OhTimePoint(2003,5,0.0), sp.getDctVec());
      assertEquals("3", 1.0,
        d3, 0.001);

      Vector dctvec = new Vector();
      dctvec.add(DataConnectionType.STEP);
      double s1 = rp.getData(
        new OhTimePoint(2003,12,0.0), dctvec);
      assertEquals("1", 2.0, s1, 0.001);
    }
    catch (OhError e) {
      System.out.println(e.what());
      fail();
    }
    
  }
  
  
  // @end{methods check} -----------------------------------------
}

