/**
 * @(#) OhRelayDouble
 *
 */

package ohymosj;

import java.util.*;
import java.io.*;

/**
 * The OhRelayDouble class is a class of port which relays
 * datapacks of type double.
 *
 * @author satoh, shiiba
 * @version $Revision: 1.11 $ $Date: 2004/01/17 02:07:31 $
 */
public class OhRelayDouble extends OhRelayPort
{
  // @begin{initialization} ----------------------------------------------

  /**
   * Initialization.
   *
   * @param aPortName a <code>String</code> value
   * @param aPortNum an <code>int</code> value
   * @exception OhError if an error occurs
   */
  public void init(String aPortName, int aPortNum) throws OhError {
    super.init(aPortName, aPortNum);
  }

  // @end{initialization} ------------------------------------------------
  
  
  // @begin {constructors} -----------------------------------------------

  /**
   * Creates a new default <code>OhRelayDouble</code> instance.
   *
   * @exception OhError if an error occurs
   */
  public OhRelayDouble() {
    super();
    _className = "OhRelayDouble";
  }

  
  /**
   * Creates a new <code>OhRelayDouble</code> instance.
   *
   * @param aPortName a <code>String</code> value
   * @param aPortNum an <code>int</code> value
   * @exception OhError if an error occurs
   */
  public OhRelayDouble(String aPortName, int aPortNum) {
    super(aPortName, aPortNum);
    _className = "OhRelayDouble";
  }

  // @end {constructors} -------------------------------------------------

  
  // @begin {methods} ----------------------------------------------------

  /**
   * Returns the data pack type which expresses the type of data to be received.
   *
   * @return a <code>String</code> value
   */
  public String dataType() {
    return "double";
  }
  // @end {methods} ------------------------------------------------------

} // OhRelayDouble
