/**
 * @(#) OhRelayFloat
 *
 */

package ohymosj;

import java.util.*;
import java.io.*;

/**
 * The OhRelayFloat class is a class of port which relays
 * datapacks of type float which extends (Ref "OhRelayPort").
 *
 * @author satoh, shiiba
 * @version $Revision: 1.2 $ $Date: 2004/01/17 13:40:48 $
 */
public class OhRelayFloat extends OhRelayPort
{
  // @begin{initialization} ------------------------------------

  /**
   * Initialization.
   *
   * @param aPortName a <code>String</code> value
   * @param aPortNum an <code>int</code> value
   * @exception OhError if an error occurs
   */
  public void init(String aPortName, int aPortNum)
    throws OhError {
    super.init(aPortName, aPortNum);
  }

  // @end{initialization} --------------------------------------
  
  
  // @begin {constructors} -------------------------------------

  /**
   * Creates a new default <code>OhRelayFloat</code> instance.
   *
   * @exception OhError if an error occurs
   */
  public OhRelayFloat() {
    super();
    _className = "OhRelayFloat";
  }

  
  /**
   * Creates a new <code>OhRelayFloat</code> instance.
   *
   * @param aPortName a <code>String</code> value
   * @param aPortNum an <code>int</code> value
   * @exception OhError if an error occurs
   */
  public OhRelayFloat(String aPortName, int aPortNum) {
    super(aPortName, aPortNum);
    _className = "OhRelayFloat";
  }

  // @end {constructors} ---------------------------------------

  
  // @begin {methods} ------------------------------------------

  /**
   * Returns the data pack type which expresses the type of data to be received.
   *
   * @return a <code>String</code> value
   */
  public String dataType() {
    return "float";
  }

  // @end {methods} --------------------------------------------

} // OhRelayFloat
