// @(#) OhSendDoubleTest.java

package ohymosj;

import junit.framework.*;
import java.util.Vector;
import java.io.StringWriter;
import java.io.PrintWriter;

public class OhSendDoubleTest extends TestCase
  implements OhConst
{
  public OhSendDoubleTest(String name) {
    super(name);
  }
  
  public void setUp() {
  }
  
  public void tearDown() {
  }

  // @begin{constructors check} ----------------------------------

  public void test_constructors() {
    // test of OhSendDouble()
    OhSendDouble a = new OhSendDouble();
    assertEquals("1", (Object)"OhSendDouble",
      a.getClassName());

    // test of OhSendDouble(String, int)
    OhSendDouble bp = new OhSendDouble("sp", 3);
    assertEquals("2", (Object)"OhSendDouble",
      bp.getClassName());
    assertEquals("3", (Object)"sp",
      bp.getObjectName());
    assertEquals("4", 3,
      bp.getObjectNumber());

    // test of OhSendDouble(String, int, Vector)
    Vector dctvec = new Vector();
    dctvec.add(DataConnectionType.STEP);
    OhSendDouble cp = new OhSendDouble("sp", 3, dctvec);
    assertEquals("5", (Object)"OhSendDouble",
      cp.getClassName());
    assertEquals("6", (Object)"sp",
      cp.getObjectName());
    assertEquals("7", 3,
      cp.getObjectNumber());
  }

  // @end{constructors check} ------------------------------------

  // @begin{methods check} ---------------------------------------

  public void test_dataType() {
    OhSendDouble sd = new OhSendDouble();
    assertEquals("1", (Object)"double", sd.dataType());
  }

  public void test_sendData() {
    OhSendDouble sp = new OhSendDouble();
    try {
      sp.doSwitch();
    }
    catch (OhError e) {
    }
    OhTimePoint tp0 = new OhTimePoint(2003, 10, 0.0);
    sp.sendData(tp0, 1.5);
    OhTimePoint tp1 = new OhTimePoint(2003, 20, 0.0);
    sp.sendData(tp1, 2.5);
    sp.setDataPackArray();

    StringWriter buffer = new StringWriter();
    PrintWriter out = new PrintWriter(buffer);
    sp.saveSendPortStock(out);
    String result = buffer.toString();
    String expected =
      "(2) # _numberOfDataPacks" + NEWLINE + NEWLINE +
      "(2003)" + NEWLINE +
      "(10)" + NEWLINE +
      "(0.0)" + NEWLINE +
      "(1.5)" + NEWLINE + NEWLINE +
      "(2003)" + NEWLINE +
      "(20)" + NEWLINE +
      "(0.0)" + NEWLINE +
      "(2.5)" + NEWLINE;
    assertEquals("1", (Object) expected, result);
  }

  public void test_sendByString() {
    OhSendDouble sp = new OhSendDouble();
    try {
      sp.doSwitch();
    }
    catch (OhError e) {
    }
    sp.sendByString("2003 10 0.0 1.5");
    sp.setDataPackArray();

    StringWriter buffer = new StringWriter();
    PrintWriter out = new PrintWriter(buffer);
    sp.saveSendPortStock(out);
    String result = buffer.toString();
    String expected =
      "(1) # _numberOfDataPacks" + NEWLINE + NEWLINE +
      "(2003)" + NEWLINE +
      "(10)" + NEWLINE +
      "(0.0)" + NEWLINE +
      "(1.5)" + NEWLINE;

    assertEquals("1", (Object) expected, result);
  }

  public void test_basicInfo() {
    OhSendDouble sp = new OhSendDouble();
    assertEquals("1",(Object) 
      ("classname: " + "OhSendDouble" + NEWLINE +
      "datatype it carries: " + "double"),
      sp.basicInfo());
  }
  
  // @end{methods check} -----------------------------------------
}

