// @(#) OhSendIntTest.java

package ohymosj;

import junit.framework.*;
import java.util.Vector;
import java.io.StringWriter;
import java.io.PrintWriter;

public class OhSendIntTest extends TestCase
  implements OhConst
{
  public OhSendIntTest(String name) {
    super(name);
  }
  
  public void setUp() {
  }
  
  public void tearDown() {
  }

  // @begin{constructors check} ----------------------------------
  
  public void test_constructors() {
    OhSendInt a = new OhSendInt();
    assertEquals("1", (Object)"OhSendInt", a.getClassName());

    OhSendInt b = new OhSendInt("sp", 3);
    assertEquals("2", (Object)"sp", b.getObjectName());
    assertEquals("3", 3, b.getObjectNumber());

    Vector dctvec = new Vector();
    dctvec.add(DataConnectionType.STEP);
    
    OhSendInt c = new OhSendInt("sp", 4, dctvec);
    assertEquals("4", (Object)"sp", c.getObjectName());
    assertEquals("5", 4, c.getObjectNumber());
  }
  
  // @end{constructors check} ------------------------------------

  // @begin{methods check} ---------------------------------------
  
  public void test_dataType() {
    OhSendInt a = new OhSendInt();
    assertEquals("1", (Object)"int", a.dataType());
  }
  
  public void test_sendData() {
    OhSendInt sp = new OhSendInt();
    try {
      sp.doSwitch();
    }
    catch (OhError e) {
    }
    OhTimePoint tp0 = new OhTimePoint(2003, 10, 0.0);
    sp.sendData(tp0, 2);
    OhTimePoint tp1 = new OhTimePoint(2003, 20, 0.0);
    sp.sendData(tp1, 3);
    sp.setDataPackArray();

    StringWriter buffer = new StringWriter();
    PrintWriter out = new PrintWriter(buffer);
    //; (Ref "OhSendPort.saveSendPortStock()")
    sp.saveSendPortStock(out);
    String result = buffer.toString();
    String expected =
      "(2) # _numberOfDataPacks" + NEWLINE + NEWLINE +
      "(2003)" + NEWLINE +
      "(10)" + NEWLINE +
      "(0.0)" + NEWLINE +
      "(2)" + NEWLINE + NEWLINE +
      "(2003)" + NEWLINE +
      "(20)" + NEWLINE +
      "(0.0)" + NEWLINE +
      "(3)" + NEWLINE;
    assertEquals("1", (Object) expected, result);
  }
  
  public void test_sendByString() {
    OhSendInt sp = new OhSendInt();
    try {
      sp.doSwitch();
    }
    catch (OhError e) {
    }
    sp.sendByString("2003 10 0.0 3");
    sp.setDataPackArray();

    StringWriter buffer = new StringWriter();
    PrintWriter out = new PrintWriter(buffer);
    sp.saveSendPortStock(out);
    String result = buffer.toString();
    String expected =
      "(1) # _numberOfDataPacks" + NEWLINE + NEWLINE +
      "(2003)" + NEWLINE +
      "(10)" + NEWLINE +
      "(0.0)" + NEWLINE +
      "(3)" + NEWLINE;

    assertEquals("1", (Object) expected, result);
  }
  
  // @end{methods check} -----------------------------------------
}

