// @(#) OhSenderPortTest.java

package ohymosj;

import junit.framework.*;
import java.util.*;
import java.io.*;
import java.util.regex.*;

public class OhSenderPortTest extends TestCase
  implements OhConst
{
  public OhSenderPortTest(String name) {
    super(name);
  }
  
  public void setUp() {
  }
  
  public void tearDown() {
  }

  class OhSenderPortMoc extends OhSenderPort {
    String _message;
    public OhSenderPortMoc() {
      super();
    }
    public OhSenderPortMoc(String aPortName, int aPortNumber) {
      super(aPortName, aPortNumber);
    }
    public String dataType() { return "double"; }
    public Vector getDctVec() { return null; }
    public void setDataPackArray() {}
    public boolean canYouGetData(OhTimePointImmutable aTFrom,
      OhTimePointImmutable aTTo) {
      return true;  
    }
    public void getDataPackArray(OhArrayList[] aDpArray,
      int[] aNumOfDp) {}
    public OhArrayList getDataPackArray() { return null; }
    public boolean getDataPack(
      Object[] aFormer, OhTimePoint aDataTime,
      Object[] aLater, char aMode) { return true;
    }
    public void reduceDataPackStock() {
      _message = "reduceDataPackStock was called";
    }
    public int getNumberOfDataPacks() { return 0; }
    public OhTimePointImmutable getNewestDataTime() {
      return new OhTimePoint(); }
    public OhTimePointImmutable getOldestDataTime() {
      return new OhTimePoint(); }
  }

  class OhReceivePortMoc extends OhReceivePort {
    // @begin{abstract_methods} --------------------------------
    public OhReceivePortMoc() {
      super();
    }
    public OhReceivePortMoc(String aPortName, int aPortNumber) {
      super(aPortName, aPortNumber);
    }
    public String dataType() {
      return "double"; 
    }
    public boolean areYouReady() {
      return true;
    }
    public void setDataPackArray() {}
    public boolean canYouGetData(
      OhTimePoint aTFrom, OhTimePoint aTTo) {
      return true;
    }
    public void getDataPackArray(
      OhArrayList[] aDpArray, int[] aNumOfDp) {}
    public OhTimePointImmutable getOldestDataTime() {
      return new OhTimePoint();
    }
    public OhTimePointImmutable getNewestDataTime() {
      return new OhTimePoint();
    }
    public int getNumberOfDataPacks() {
      return 0;
    }
    public boolean getDataPack(
      Object[] aFormer, OhTimePoint _dataTime,
      Object[] aLater, char aMode)
      {
        return true;
      }
    public OhTimePointImmutable getNecessaryTimeTo() {
      return new OhTimePoint();
    }
    public OhTimePointImmutable getNecessaryTimeFrom() {
      return new OhTimePoint();
    }
    // @end{abstract_methods} ----------------------------------
  }
  
  public void test_foo() {}

  // @begin{constructors check} ----------------------------------
  // @end{constructors check} ------------------------------------

  // @begin{methods check} ----------------------------------<-----

  public void test_areYouReady() {
    OhSenderPort a = new OhSenderPortMoc("sp", 0);
    OhReceivePort b = new OhReceivePortMoc("rp", 1);
    try {
      a.registerReceiver(b);
      assertEquals("test_areYouReadyA", false, a.areYouReady());
      a.doSwitch();
    }
    catch (OhError e) {
    }
    assertEquals("test_areYouReadyB", true, a.areYouReady());
  }
    
  public void test_printConnection() {
    StringWriter buffer = new StringWriter();
    PrintWriter out = new PrintWriter(buffer);
    OhSenderPort a = new OhSenderPortMoc("sp", 0);
    a.printConnection(out, "> ");
    boolean match = Pattern.matches(
      "(?s).*Not connected.*", buffer.toString());
    if (!match) {
      fail("The result of printConnection() does not match with one expteced.");
    }

    StringWriter buffera = new StringWriter();
    PrintWriter outa = new PrintWriter(buffera);

    OhReceivePort b = new OhReceivePortMoc("rp", 1);
    try {
      a.registerReceiver(b);
      a.doSwitch();
    }
    catch (OhError e) {
      System.out.println(e.what());
    }

    a.printConnection(outa, "% ");
    String expected =
      "% (" + NEWLINE +
      "%  OhSenderPort sp 0" + NEWLINE +
      "% )" + NEWLINE +
      "% Connected > (" + NEWLINE +
      "% Connected >  OhReceivePort rp 1" + NEWLINE +
      "% Connected > )" + NEWLINE;
    assertEquals("test_printConnection", (Object)expected,
      buffera.toString());
  }
  
  public void test_reduceDataPackStock() {
    OhSenderPort a = new OhSenderPortMoc();
    a.reduceDataPackStock();
    assertEquals("test_reduceDataPackStock",
      "reduceDataPackStock was called",
      ((OhSenderPortMoc) a)._message);
  }
  
  // @end{methods check} -----------------------------------------
}

