// @(#) class OhTimeTest

/*
 * created: 2004/01/04
 *
 */
package ohymosj;

import junit.framework.TestCase;

/**
 * <japanese>
 * <br>
 * Rg}܂B
 * </japanese>
 * 
 * @author shiiba
 *
 */
public class OhTimeTest extends TestCase {

  /**
   * Constructor for OhTimeTest.
   * @param arg0
   */
  public OhTimeTest(String arg0) {
    super(arg0);
  }

  /*
   * void OhTime ̃eXg()
   */
  public void testOhTime() {
    OhTime t = new OhTime();
    assertEquals("testOhTime",   0, t.getSec());
    assertEquals("testOhTime", 0.0, t.getFrac(), 0.0001);
  }

  /*
   * void OhTime ̃eXg(long, double)
   */
  public void testOhTimelongdouble() {
    OhTime ta = new OhTime(10, 0.3);
    assertEquals("testOhTimelongdoubleA",  10, ta.getSec());
    assertEquals("testOhTimelongdoubleB", 0.3, ta.getFrac(), 0.0001);
    OhTime td = new OhTime(-10, -0.3);
    assertEquals("testOhTimelongdoubleG",  -10, td.getSec());
    assertEquals("testOhTimelongdoubleH", -0.3, td.getFrac(), 0.0001);
  }
  
  public void testOhTimeDouble() {
    OhTime time = new OhTime(2.3);
    assertEquals("OhTimeDouble1",   2, time.getSec());
    assertEquals("OhTimeDouble2", 0.3, time.getFrac(), 0.0001);
    OhTime timeb = new OhTime(-2.3);
    assertEquals("OhTimeDouble1",   -2, timeb.getSec());
    assertEquals("OhTimeDouble2", -0.3, timeb.getFrac(), 0.0001);
  }

  public void testAdd() {
    OhTime ta = new OhTime(3, -0.4);
    OhTime tb = new OhTime(2, -0.3);
    OhTime tc = OhTime.add(ta, tb);
    assertEquals("testAdd1",   4, tc.getSec());
    assertEquals("testAdd2", 0.3, tc.getFrac(), 0.0001);
    ta.add(tb);
    assertEquals("testAdd3",   4, ta.getSec());
    assertEquals("testAdd4", 0.3, ta.getFrac(), 0.0001);
    OhTime td = new OhTime(-2, -0.9);
    ta.add(td);
    assertEquals("testAdd5",   1, ta.getSec());
    assertEquals("testAdd6", 0.4, ta.getFrac(), 0.0001);
  }
  
  public void testSub() {
    OhTime ta = new OhTime(4, -0.4);
    OhTime tb = new OhTime(2, -0.3);
    OhTime tc = OhTime.sub(ta, tb);
    assertEquals("testsub1",    2, tc.getSec());
    assertEquals("testsub2", -0.1, tc.getFrac(), 0.0001);
    ta.sub(tb);
    assertEquals("testAdd3",    2, ta.getSec());
    assertEquals("testAdd4", -0.1, ta.getFrac(), 0.0001);
  }
  
  public void testCopy() {
    OhTime ta = new OhTime(4, -0.3);
    OhTime tb = new OhTime(2, 0.3);
    ta.copy(tb);
    assertEquals("testCopya", 2, tb.getSec());
    assertEquals("testCopyb", 0.3, tb.getFrac(), 0.0001);
  }
  
  public void testToDouble() {
    OhTime ta = new OhTime(4, -0.3);
    assertEquals("testToDouble", 3.7, ta.toDouble(), 0.0001);
  }
  
  public void testMul() {
    OhTime ta = new OhTime(4, -0.3);
    OhTime tb = OhTime.mul(ta, 3);
    assertEquals("testMula", 11, tb.getSec());
    assertEquals("testMula", 0.1, tb.getFrac(), 0.0001);
    ta.mul(3);
    assertEquals("testMula", 11, ta.getSec());
    assertEquals("testMula", 0.1, ta.getFrac(), 0.0001);
  }

  public void testClone() {
    OhTime ta = new OhTime(3, 0.4);
    OhTime tb = (OhTime)ta.clone();
    assertEquals("testCloneA", 3, tb.getSec());
    assertEquals("testCloneA", 0.4, tb.getFrac(), 0.0001);
    assertEquals("testCloneA", true, tb.equals(ta));

    OhTimeImmutable tc = (OhTimeImmutable) ta;
    assertEquals("testCloneA", 3, tc.getSec());
    assertEquals("testCloneA", 0.4, tc.getFrac(), 0.0001);
  }

  public void test_equalsObjDouble() {
    OhTime ta = new OhTime(3, 0.4);
    OhTime tb = new OhTime(3, 0.400001);
    assertEquals("test_equalsObjDouble", true, tb.equals(ta, 0.0001));
  }
}
